;TDL
; serialize @ parallel port A(what'S with adc??) and B and C 
;status LED's still on @ runnin' mode??












.include "m32def.inc"

; Autor: Frank Simon and kai scheddin
; Datum: 11.6.2005
; Aufgabe:  Spannung (0-5V) an PC0 (Pin 23) anlegen. Das Programm wartet auf
;			ein bliebiges Byte am UART, startet die AD-Wandlung und sendet
;			das Wandlungsergebnis ber den UART zurck.

                
.MESSAGE "TU-Berlin, nemesis projekt, rs232 communication ware (c) kai scheddin"
.def temp = R16
.def poc = r19
.def pob = r23
.def get =r20
.def send =r21
.def mpr  = r22
;.def numberL  = XL  ;number stores the hex value
;.def numberH  = XH
.def bcd1000  = r1  ;these registers will contain
.def bcd100  = r2  ;the binary coded decimals.
.def bcd10  = r3
.def bcd1  = r4
.cseg

;############################################################
; *.dlib data libary,.. including .def and .equ
.include "lib\button.dlib"
.include "lib\product.dlib"
.include "lib\ascii.dlib"
.include "lib\usart.dlib"
;############################################################







;############################################################
;here including origins .org
.org 0x00
		jmp reset

.org URXCaddr					;Interruptvektor fr UART-Empfang
		jmp int_RXD
;############################################################


;############################################################
;here including subroutines
.include "lib\usart.asm"
.include "lib\math.asm"

.MACRO lc_modus
        cpi get, @0
		brne ende_lc_abfrage
        ldi temp, @1
        eor pob, temp
        out PORTB,pob
     	mov send,temp
		call sendbyte
		ldi send,ACK
		call sendbyte
		call term
		
		jmp end_int_rxd
ende_lc_abfrage:
.ENDMACRO

.MACRO lc_conf
		cpi get, @0
		brne ende_lc_conf
        
        ldi temp, @1
        eor poc, temp
        out PORTC,poc
     	mov send,temp
		call sendbyte
		ldi send,ACK
		call sendbyte
		call term
		
		jmp end_int_rxd
ende_lc_conf:
.ENDMACRO


;############################################################
reset:	
		 
         
		ldi get,0x00
		ldi send,0x00

		;##########################################################
		;PortC fr ausgabe initialisieren
		ldi temp, 0xFF       ;0xFF ins Arbeitsregister r16 laden
        out DDRC, temp       ;Inhalt von r16 ins IO-Register DDRC ausgeben
        ldi poc, 0b00001000 ;0b00000001 in r16 laden (c4 -> all is gnd)
		out PORTC, poc      ;r16 ins IO-Register PORTC ausgeben
        ;PortB fr Asugabe initialisieren
		ldi temp, 0xFF       ;0xFF ins Arbeitsregister r16 laden
        out DDRB, temp       ;Inhalt von r16 ins IO-Register DDRC ausgeben
        ldi pob, 0b00000000 ;0b00000000 in r16 laden (port c
		out PORTB, pob      ;r16 ins IO-Register PORTC ausgeben
				

		ldi temp, LOW(RAMEND)	;Stackpointer initialisieren
        out SPL, temp
        ldi temp, HIGH(RAMEND)
        out SPH, temp
        
	    call USART_init
		
		ldi temp, 0b01011000	;Messbereich 0-5V, Kanal 0pos - 2neg differnential
		out ADMUX, temp
		ldi temp, 0b10000111	;ADC an, CLK=8MHz/128
		out ADCSRA, temp
        sei						;Interrupts global aktivieren                               
        rcall info        

		      
;############################################################################
wait:
sei
rjmp wait    

       
main:
	 sei
	 ldi send, STX                      ; die Bytes 10 und 13 senden
     rcall sendbyte                    ; (Zeilenumbruch im Terminal)
     
ADC_START: 	clr temp
		    sbi	ADCSR,ADSC			;Wandlung starten
        
warte_bis_feddich_gemessen:	
		sbis ADCSR,ADIF			;Warten bis Wandlung beendet ist
		rjmp warte_bis_feddich_gemessen

        
	
        in zl, ADCL			;Die unteren 8 Bit in r17 merken
        in zh, ADCH			;Die oberen 2 Bit in r18 merken


		push temp
		mov temp,zl
        
		
		mov temp,zl
		rcall hex2bcd

        mov send,r23
		rcall sendbyte
		mov send,r22
		rcall sendbyte
        mov send,temp
		rcall sendbyte
		

        ldi send, LF                       ; die Bytes 10 und 13 senden
        rcall sendbyte                    ; (Zeilenumbruch im Terminal)
        ldi send, CR
        rcall sendbyte
        
		ldi send, ETX
        rcall sendbyte  
		
		pop temp
		
		rjmp main
;############################################################################
; Interruptroutine wird ausgefhrt wenn ein Byte ber UART empfangen wurde
int_RXD:
		in temp,SREG
		push temp
		in get,UDR
		cpi get,0
		brne PC + 2
        rjmp end_int_rxd
		 
 
        cpi get,SI ;(ende der aufzeichnung)
		brne PC + 5
		pop temp
		out SREG,temp
		cli
		rjmp wait
		
		
		cpi get,255 ;(Grundstellung)
		brne PC + 4
		pop temp
		out SREG,temp
		rjmp reset ;hier auch statusregister sichern??
		
		lc_modus 1,0b00000001 
		lc_modus 2,0b00000010 
		lc_modus 3,0b00000100 
		lc_modus 4,0b00001000 
		lc_modus 5,0b00010000 
		lc_modus 6,0b00100000 
		lc_modus 7,0b01000000 
		lc_modus 8,0b10000000
		
		lc_conf 9, 0b00000001
		lc_conf 10,0b00000010
		lc_conf 11,0b00000100
		lc_conf 12,0b00001000
		
		cpi get,SO ;(Umschaltung (op call) ->run)
		brne PC + 2
		rjmp run

		
 
        ldi send,CAN
		rcall sendbyte 
		 
		 
        rjmp end_int_rxd
;#################################################################################


run:
ldi send,'k'
rcall sendbyte
ldi send,ACK
rcall sendbyte
pop temp
out SREG,temp
cli
jmp main


term:  
      ldi send,CR
	  rcall sendbyte
	  rcall waitcmd
	  ret

waitcmd:
      clr zl
	  clr zh
	  ldi zl,low(wait_cmd*2)
	  ldi zh,high(wait_cmd*2)
	  call print
	  ret

end_int_rxd:		 
	  call term
	  pop temp
	  out SREG,temp
	  reti
end_int_rxd2:
	  pop temp
	  out SREG,temp
	  reti


check: ret ;zeichenabfrage


info:
        rcall help
        rcall waitcmd
		reti


help:
        ldi ZL, LOW(helptext*2)               ; Adresse des Strings in den
        ldi ZH, HIGH(helptext*2)              ; Z-Pointer laden
        rcall print 
		ret 


status: 

        ldi poc,0b11111110
		out PORTC,poc

		ldi ZL, LOW(statustext1*2)               ; Adresse des Strings in den
        ldi ZH, HIGH(statustext1*2)              ; Z-Pointer laden
        rcall print                       ; Unterfunktion print aufrufen

	    ldi ZL, LOW(statustext2*2)               ; Adresse des Strings in den
        ldi ZH, HIGH(statustext2*2)              ; Z-Pointer laden
        rcall print 

        rcall ADC_START
       
		ldi send, LF                       ; die Bytes 10 und 13 senden
        rcall sendbyte                    ; (Zeilenumbruch im Terminal)
        ldi send, CR
        rcall sendbyte
        
		mov temp,zl
		rcall hex2bcd

        mov send,r23
		rcall sendbyte
		mov send,r22
		rcall sendbyte
		mov send,temp
		rcall sendbyte
        ldi send, 32                       ; die Bytes 10 und 13 senden
        rcall sendbyte                    ; (Zeilenumbruch im Terminal)		

		ldi send, LF                       ; die Bytes 10 und 13 senden
        rcall sendbyte                    ; (Zeilenumbruch im Terminal)
        ldi send, CR
        rcall sendbyte

        reti


      
end: nop 
	 jmp end


;muss im codesegment stehen,... sonst baut der nur shice

rxd_buffer: .dw 0x460 
wait_cmd: .db 10,13,"muC>",0
statustext1: .db 10,13,"status:",10,13,0x04,0
statustext2: .db "AD channel7-pegel:",10,13,0x04,0
statustext3: .db "you enter'd:",0
LEDtext1: .db 10,13,"LED:",0x04,0
done: .db 10,13,"......done..",0x04,0
helptext: .db "==========================================",10,13,"kai's uart com portal",10,13,"(c) tu-berlin, nemesis project",10,13,"==========================================",10,13,"send ascii code-001 for status",10,13,"ascii code-010 to clear all led's",10,13,"code-011 to set them on again",10,13,"code-255 to restart the ATmega32(tm)",10,13,"and code-110 for help",10,13,"==========================================",10,13,0x04,0



