;#####################################################
; Usart.asm
;#####################################################
USART_init:
		ldi temp, LOW(UBRRVAL)	;Baudrate einstellen
        out UBRRL, temp
        ldi temp, HIGH(UBRRVAL)
        out UBRRH, temp
        ldi temp, (1<<URSEL)|(3<<UCSZ0)	;Frame-Format: 8 Bit
        out UCSRC, temp
        sbi UCSRB, RXCIE        ;Interrupt bei Empfang
		sbi UCSRB, RXEN         ;Empfang aktivieren
		sbi UCSRB,TXEN          ;Senden aktivieren  
		call rxd_alloc
		ret
; print: sendet die durch den Z-Pointer adressierte Zeichenkette
rxd_alloc:
          ldi xl,low(rxd_buffer*2)
		  ldi xh,high(rxd_buffer*2)
		  ret

print:
        lpm                               ; Erstes Byte des Strings nach R0 lesen
        tst R0                            ; R0 auf 0 testen
        breq print_end                    ; wenn 0, dann zu print_end
        mov send, r0                       ; Inhalt von R0 nach send kopieren
        rcall sendbyte                    ; UART-Sendefunktion aufrufen
        adiw ZL, 1                        ; Adresse des Z-Pointers um 1 erhhen
        rjmp print                        ; wieder zum Anfang springen
print_end:
        ret

; sendbyte: sendet das Byte aus R16 ber das UART
sendbyte:
        sbis UCSRA, UDRE                  ; warten bis das UART bereit ist
         rjmp sendbyte
        out UDR, send
        ret
